/*
 * Pair.cpp
 *
 *  Created on: Oct 7, 2008
 *      Author: bloch
 */

#include "Pair.h"
#include <iostream>
using std::cerr;
using std::endl;


Pair::Pair(const Pair &other) : x(other.x), y(other.y) { 
	cerr << "Copy-constructing Pair(" << x << "," << y << ")" <<
endl;
	}

const Pair & Pair::operator=(const Pair &source) {
	x = source.x;
	y = source.y;
	cerr << "Assigning Pair(" << x << "," << y << ")" <<
endl;
	return *this; // or source; shouldn't matter
	}

Pair::~Pair() {
	cerr << "Destroying Pair(" << x << "," << y << ")" << endl;
	}

bool Pair::operator==(const Pair &right) const {
// Try taking out one or both of the "const"s.  What happens?
	return x == right.x && y == right.y;
	}

ostream &Pair::printTo(ostream &out) const {
	return out << "(" << x << "," << y << ")";
	}
	
ostream & operator<< (ostream &out, const Pair &p) {
	return p.printTo (out);
	}
