/*
 * Pair.h
 *
 *  Created on: Oct 7, 2008
 *      Author: bloch
 */

#ifndef PAIR_H_
#define PAIR_H_

#include <iostream>
using std::cerr;
using std::endl;
using std::ostream;

class Pair {
private:
	int x, y;
public:
	Pair(int xarg=0, int yarg=0) : x(xarg), y(yarg) {
		x = xarg;
		y = yarg;
		cerr << "Constructing Pair(" << xarg << "," << yarg << ")" << endl;
		}
	// Since this now allows 0, 1, or 2 arguments, it counts as a
	// default constructor.

	Pair(const Pair & old);	// copy constructor 
	const Pair & operator=(const Pair &source); // assignment operator 
	~Pair();		// destructor
	bool operator==(const Pair &right) const; // equality operator
	ostream &printTo(ostream &out) const; // does the work of <<

	int getX() const { return x; }
	int getY() const { return y; }
};

ostream & operator<< (ostream &out, const Pair &p); // << operator
#endif /* PAIR_H_ */
